pkgsrc-Changes archive

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]

CVS commit: pkgsrc/lang/rust176-bin



Module Name:    pkgsrc
Committed By:   wiz
Date:           Sun Jul  7 10:56:19 UTC 2024

Added Files:
        pkgsrc/lang/rust176-bin: DESCR Makefile buildlink3.mk distinfo
        pkgsrc/lang/rust176-bin/files: install.sh

Log Message:
lang/rust176-bin: import rust-bin-1.76.0

Rust is a systems programming language focused on three goals: safety,
speed, and concurrency.  It maintains these goals without having a
garbage collector, making it a useful language for a number of use cases
other languages aren't good at: embedding in other languages, programs
with specific space and time requirements, and writing low-level code,
like device drivers and operating systems.

It improves on current languages targeting this space by having a number
of compile-time safety checks that produce no runtime overhead, while
eliminating all data races.  Rust also aims to achieve "zero-cost
abstractions" even though some of these abstractions feel like those of
a high-level language.  Even then, Rust still allows precise control
like a low-level language would.

This package installs a released binary, on architectures supported by
upstream, or a TNF-built binary, on NetBSD versions not supported by
upstream.

This is the old 1.76 version of rust for those platforms where the current
version does not work.


To generate a diff of this commit:
cvs rdiff -u -r0 -r1.1 pkgsrc/lang/rust176-bin/DESCR \
    pkgsrc/lang/rust176-bin/Makefile pkgsrc/lang/rust176-bin/buildlink3.mk \
    pkgsrc/lang/rust176-bin/distinfo
cvs rdiff -u -r0 -r1.1 pkgsrc/lang/rust176-bin/files/install.sh

Please note that diffs are not public domain; they are subject to the
copyright notices on the relevant files.

Added files:

Index: pkgsrc/lang/rust176-bin/DESCR
diff -u /dev/null pkgsrc/lang/rust176-bin/DESCR:1.1
--- /dev/null   Sun Jul  7 10:56:19 2024
+++ pkgsrc/lang/rust176-bin/DESCR       Sun Jul  7 10:56:19 2024
@@ -0,0 +1,20 @@
+Rust is a systems programming language focused on three goals: safety,
+speed, and concurrency.  It maintains these goals without having a
+garbage collector, making it a useful language for a number of use cases
+other languages aren't good at: embedding in other languages, programs
+with specific space and time requirements, and writing low-level code,
+like device drivers and operating systems.
+
+It improves on current languages targeting this space by having a number
+of compile-time safety checks that produce no runtime overhead, while
+eliminating all data races.  Rust also aims to achieve "zero-cost
+abstractions" even though some of these abstractions feel like those of
+a high-level language.  Even then, Rust still allows precise control
+like a low-level language would.
+
+This package installs a released binary, on architectures supported by
+upstream, or a TNF-built binary, on NetBSD versions not supported by
+upstream.
+
+This is the old 1.76 version of rust for those platforms where the current
+version does not work.
Index: pkgsrc/lang/rust176-bin/Makefile
diff -u /dev/null pkgsrc/lang/rust176-bin/Makefile:1.1
--- /dev/null   Sun Jul  7 10:56:19 2024
+++ pkgsrc/lang/rust176-bin/Makefile    Sun Jul  7 10:56:19 2024
@@ -0,0 +1,287 @@
+# $NetBSD: Makefile,v 1.1 2024/07/07 10:56:19 wiz Exp $
+
+DISTNAME=      rust-1.76.0
+PKGNAME=       ${DISTNAME:S/rust/rust-bin/1}
+CATEGORIES=    lang
+MASTER_SITES=  https://static.rust-lang.org/dist/
+DIST_SUBDIR=   ${PKGNAME_NOREV}
+
+MAINTAINER=    pkgsrc-users%NetBSD.org@localhost
+HOMEPAGE=      https://rust-lang.org/
+COMMENT=       Safe, concurrent, practical language (pre-built distribution)
+LICENSE=       mit OR apache-2.0
+
+CONFLICTS+=    rust-[0-9]*
+
+# Rust upstream provided binaries
+ONLY_FOR_PLATFORM+=    Darwin-*-aarch64
+ONLY_FOR_PLATFORM+=    Darwin-*-x86_64
+ONLY_FOR_PLATFORM+=    FreeBSD-*-x86_64
+ONLY_FOR_PLATFORM+=    Linux-*-aarch64
+ONLY_FOR_PLATFORM+=    Linux-*-i386
+ONLY_FOR_PLATFORM+=    Linux-*-x86_64
+ONLY_FOR_PLATFORM+=    NetBSD-*-x86_64
+
+# he%NetBSD.org@localhost provided binaries
+ONLY_FOR_PLATFORM+=    NetBSD-*-aarch64
+ONLY_FOR_PLATFORM+=    NetBSD-*-aarch64eb
+ONLY_FOR_PLATFORM+=    NetBSD-*-earmv7hf
+ONLY_FOR_PLATFORM+=    NetBSD-*-earmv6hf
+ONLY_FOR_PLATFORM+=    NetBSD-*-i386
+ONLY_FOR_PLATFORM+=    NetBSD-*-powerpc
+ONLY_FOR_PLATFORM+=    NetBSD-*-sparc64
+ONLY_FOR_PLATFORM+=    NetBSD-*-mipsel
+ONLY_FOR_PLATFORM+=    NetBSD-*-riscv64
+
+# Illumos, jperkin@ provided binaries
+ONLY_FOR_PLATFORM+=    SunOS-*-x86_64
+
+NETBSD_REPO=   https://cdn.NetBSD.org/pub/pkgsrc/distfiles/LOCAL_PORTS/rust/
+
+CHECK_RELRO_SKIP+=     lib/rustlib/*/bin/*
+
+CHECK_SHLIBS_SKIP+=    bin/cargo-clippy
+CHECK_SHLIBS_SKIP+=    bin/rustfmt
+
+# All kits are now built for 9.0.
+BROKEN_ON_PLATFORM+=   NetBSD-8.*
+
+# Binary distributions aren't built as PIE.
+MKPIE_SUPPORTED=       no
+
+NO_BUILD=      yes
+USE_TOOLS+=    bash pax
+WRKSRC=                ${WRKDIR}/${DISTFILES:C/.tar.[gx]z//}
+
+GENERATE_PLIST+=       find ${DESTDIR}${PREFIX} \( -type f -o -type l \) -print | \
+                       sed 's,${DESTDIR}${PREFIX}/,,' | ${SORT} ;
+
+INSTALLATION_DIRS=     bin ${PKGMANDIR} share/doc/cargo/bash_completion.d
+
+.include "../../mk/bsd.prefs.mk"
+
+.if ${OPSYS} == "NetBSD" && ${OPSYS_VERSION} < 080000
+BROKEN+=               "Bootstrap unavailable for old NetBSD version"
+.endif
+
+DISTFILES:=    # empty
+
+# Rust upstream provided binaries
+
+.if ${MACHINE_PLATFORM:MDarwin-*-aarch64} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    aarch64-apple-darwin
+DISTFILES:=    ${DISTFILES} ${DISTNAME}-${RUST_ARCH}.tar.gz
+.endif
+.if ${MACHINE_PLATFORM:MDarwin-*-x86_64} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    x86_64-apple-darwin
+DISTFILES:=    ${DISTFILES} ${DISTNAME}-${RUST_ARCH}.tar.gz
+.endif
+.if ${MACHINE_PLATFORM:MFreeBSD-*-x86_64} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    x86_64-unknown-freebsd
+DISTFILES:=    ${DISTFILES} ${DISTNAME}-${RUST_ARCH}.tar.gz
+.endif
+.if ${MACHINE_PLATFORM:MLinux-*-i386} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    i686-unknown-linux-gnu
+DISTFILES:=    ${DISTFILES} ${DISTNAME}-${RUST_ARCH}.tar.gz
+.endif
+.if (${MACHINE_PLATFORM:MLinux-*-aarch64} && !empty(GLIBC_VERSION)) || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    aarch64-unknown-linux-gnu
+DISTFILES:=    ${DISTFILES} ${DISTNAME}-${RUST_ARCH}.tar.gz
+.endif
+.if (${MACHINE_PLATFORM:MLinux-*-aarch64} && empty(GLIBC_VERSION)) || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    aarch64-unknown-linux-musl
+DISTFILES:=    ${DISTFILES} ${DISTNAME}-${RUST_ARCH}.tar.gz
+.endif
+.if (${MACHINE_PLATFORM:MLinux-*-x86_64} && !empty(GLIBC_VERSION)) || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    x86_64-unknown-linux-gnu
+DISTFILES:=    ${DISTFILES} ${DISTNAME}-${RUST_ARCH}.tar.gz
+.endif
+.if (${MACHINE_PLATFORM:MLinux-*-x86_64} && empty(GLIBC_VERSION)) || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    x86_64-unknown-linux-musl
+DISTFILES:=    ${DISTFILES} ${DISTNAME}-${RUST_ARCH}.tar.gz
+.endif
+.if ${MACHINE_PLATFORM:MNetBSD-*-x86_64} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    x86_64-unknown-netbsd
+DISTFILES:=    ${DISTFILES} ${DISTNAME}-${RUST_ARCH}.tar.gz
+.endif
+
+# NetBSD provided binaries:
+
+NBSUF=
+
+.if ${MACHINE_PLATFORM:MNetBSD-*-aarch64} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    aarch64-unknown-netbsd
+DN:=           ${DISTNAME}${NBSUF}
+EXTRACT_SUFX=  .tar.xz
+DF:=           ${DN}-${RUST_ARCH}${EXTRACT_SUFX}
+DISTFILES:=    ${DISTFILES} ${DF}
+SITES.${DF}=   ${NETBSD_REPO}
+.endif
+.if ${MACHINE_PLATFORM:MNetBSD-*-aarch64eb} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    aarch64_be-unknown-netbsd
+DN:=           ${DISTNAME}${NBSUF}
+EXTRACT_SUFX=  .tar.xz
+DF:=           ${DN}-${RUST_ARCH}${EXTRACT_SUFX}
+DISTFILES:=    ${DISTFILES} ${DF}
+SITES.${DF}=   ${NETBSD_REPO}
+.endif
+.if ${MACHINE_PLATFORM:MNetBSD-*-earmv6hf} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    armv6-unknown-netbsd-eabihf
+DN:=           ${DISTNAME}${NBSUF}
+EXTRACT_SUFX=  .tar.xz
+DF:=           ${DN}-${RUST_ARCH}${EXTRACT_SUFX}
+DISTFILES:=    ${DISTFILES} ${DF}
+SITES.${DF}=   ${NETBSD_REPO}
+.endif
+.if ${MACHINE_PLATFORM:MNetBSD-*-earmv7hf} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    armv7-unknown-netbsd-eabihf
+DN:=           ${DISTNAME}${NBSUF}
+EXTRACT_SUFX=  .tar.xz
+DF:=           ${DN}-${RUST_ARCH}${EXTRACT_SUFX}
+DISTFILES:=    ${DISTFILES} ${DF}
+SITES.${DF}=   ${NETBSD_REPO}
+.endif
+.if ${MACHINE_PLATFORM:MNetBSD-*-i386} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    i586-unknown-netbsd
+DN:=           ${DISTNAME}${NBSUF}
+EXTRACT_SUFX=  .tar.xz
+DF:=           ${DN}-${RUST_ARCH}${EXTRACT_SUFX}
+DISTFILES:=    ${DISTFILES} ${DF}
+SITES.${DF}=   ${NETBSD_REPO}
+.endif
+.if ${MACHINE_PLATFORM:MNetBSD-*-powerpc} || make(distinfo) || make(makesum) || make(mdi)
+# Now only supports OS_VERSION >= 9.0
+RUST_ARCH:=    powerpc-unknown-netbsd
+DN:=           ${DISTNAME}${NBSUF}
+EXTRACT_SUFX=  .tar.xz
+DF:=           ${DN}-${RUST_ARCH}${EXTRACT_SUFX}
+DISTFILES:=    ${DISTFILES} ${DF}
+SITES.${DF}=   ${NETBSD_REPO}
+.endif
+.if ${MACHINE_PLATFORM:MNetBSD-*-sparc64} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    sparc64-unknown-netbsd
+DN:=           ${DISTNAME}${NBSUF}
+EXTRACT_SUFX=  .tar.xz
+DF:=           ${DN}-${RUST_ARCH}${EXTRACT_SUFX}
+DISTFILES:=    ${DISTFILES} ${DF}
+SITES.${DF}=   ${NETBSD_REPO}
+.endif
+.if ${MACHINE_PLATFORM:MNetBSD-*-mipsel} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    mipsel-unknown-netbsd
+DN:=           ${DISTNAME}${NBSUF}
+EXTRACT_SUFX=  .tar.xz
+DF:=           ${DN}-${RUST_ARCH}${EXTRACT_SUFX}
+DISTFILES:=    ${DISTFILES} ${DF}
+SITES.${DF}=   ${NETBSD_REPO}
+.endif
+.if ${MACHINE_PLATFORM:MNetBSD-*-riscv64} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    riscv64gc-unknown-netbsd
+DN:=           ${DISTNAME}${NBSUF}
+EXTRACT_SUFX=  .tar.xz
+DF:=           ${DN}-${RUST_ARCH}${EXTRACT_SUFX}
+DISTFILES:=    ${DISTFILES} ${DF}
+SITES.${DF}=   ${NETBSD_REPO}
+.endif
+
+# Illumos:
+.if ${MACHINE_PLATFORM:MSunOS-*-x86_64} || make(distinfo) || make(makesum) || make(mdi)
+RUST_ARCH:=    x86_64-unknown-illumos
+DN:=           ${DISTNAME}
+EXTRACT_SUFX=  .tar.gz
+DF:=           ${DN}-${RUST_ARCH}${EXTRACT_SUFX}
+DISTFILES:=    ${DISTFILES} ${DF}
+SITES.${DF}=   https://us-central.manta.mnx.io/pkgsrc/public/pkg-bootstraps/
+.endif
+
+
+# Binary still extracts to plain non-nb'ed directory
+WRKSRC:=       ${WRKSRC:C/nb[0-9]*//}
+# Undo the powerpc netbsd90 thingie...
+WRKSRC:=       ${WRKSRC:C/netbsd90/netbsd/}
+
+do-install:
+       cd ${.CURDIR}/files; pax -rw install.sh ${WRKSRC}
+       cd ${WRKSRC} && env PKGMANDIR=${PKGMANDIR} bash ./install.sh \
+       --destdir=${DESTDIR} --prefix=${PREFIX}
+       ${RM} -f ${DESTDIR}${PREFIX}/lib/rustlib/${RUST_ARCH}/bin/rust-llvm-dwp
+       ${RM} -f ${DESTDIR}${PREFIX}/lib/rustlib/install.log
+       ${RM} -f ${DESTDIR}${PREFIX}/lib/rustlib/manifest-*
+       ${RM} -f ${DESTDIR}${PREFIX}/lib/rustlib/uninstall.sh
+
+.if ${OPSYS} == "Darwin"
+.PHONY: fix-darwin-install-name
+post-install: fix-darwin-install-name
+fix-darwin-install-name:
+.  for bin in clippy-driver miri rls rust-analyzer rustc rustdoc
+       otool -XL ${DESTDIR}${PREFIX}/bin/${bin}                        \
+           | ${GREP} '@rpath' | while read rpath rest; do              \
+               install_name_tool -change $$rpath                       \
+                   `${ECHO} $$rpath | ${SED} -e 's,@rpath,${PREFIX}/lib,g'` \
+                   ${DESTDIR}${PREFIX}/bin/${bin};                     \
+       done
+.  endfor
+.  for bin in lldb lldb-mi llvm-nm llvm-objcopy llvm-objdump   \
+               llvm-profdata llvm-readobj llvm-size llvm-strip
+       otool -XL ${DESTDIR}${PREFIX}/lib/rustlib/${RUST_ARCH}/bin/${bin} \
+           | ${GREP} '@rpath' | while read rpath rest; do              \
+               install_name_tool -change $$rpath                       \
+                   `${ECHO} $$rpath | ${SED} -e 's,@rpath,${PREFIX}/lib/rustlib/${RUST_ARCH}/lib,g'` \
+                   ${DESTDIR}${PREFIX}/lib/rustlib/${RUST_ARCH}/bin/${bin}; \
+       done
+.  endfor
+.  for lib in lib lib/rustlib/${RUST_ARCH}/lib lib/rustlib/${RUST_ARCH}/codegen-backends
+       for f in ${DESTDIR}${PREFIX}/${lib}/lib*.dylib; do              \
+               [ ! -f $$f ] && continue;                               \
+               install_name_tool -id `${ECHO} $$f | ${SED} -e 's,${DESTDIR},,g'` $$f; \
+               otool -XL $$f | grep '@rpath' | while read rpath rest; do \
+                       install_name_tool -change $$rpath \
+                           `${ECHO} $$rpath | ${SED} -e 's,@rpath,${PREFIX}/lib,g'` \
+                           $$f;                                        \
+               done;                                                   \
+       done
+.  endfor
+
+.else
+# Not Darwin:
+
+TOOL_DEPENDS+=         patchelf-[0-9]*:../../devel/patchelf
+
+RUST_LLVM_RPATH=       ${PREFIX}/lib
+FORCE_RPATH=           --force-rpath
+
+# 32-bit NetBSD ports need libatomic
+.  if ${MACHINE_PLATFORM:MNetBSD-*-powerpc} || \
+      ${MACHINE_PLATFORM:MNetBSD-*-earmv[67]hf} || \
+      ${MACHINE_PLATFORM:MNetBSD-*-mipsel} || \
+      ${MACHINE_PLATFORM:MNetBSD-*-i386}
+.    include "../../devel/libatomic/buildlink3.mk"
+.  endif
+
+.PHONY: fix-relative-rpath
+post-install: fix-relative-rpath
+fix-relative-rpath:
+.  for bin in clippy-driver miri rls rust-analyzer rustc rustdoc
+       if [ -f ${DESTDIR}${PREFIX}/bin/${bin} ]; then \
+               ${PREFIX}/bin/patchelf ${FORCE_RPATH} --set-rpath \
+                   ${PREFIX}/lib ${DESTDIR}${PREFIX}/bin/${bin} ; \
+       fi
+.  endfor
+# Only Linux builds link these binaries against an LLVM library
+.  if ${OPSYS} == "Linux"
+.    for bin in llc llvm-ar llvm-as llvm-cov llvm-dis llvm-nm llvm-objcopy \
+          llvm-objdump llvm-profdata llvm-readobj llvm-size llvm-strip opt \
+          rust-lld gcc-ld/ld64.lld gcc-ld/ld.lld gcc-ld/lld-link gcc-ld/wasm-ld
+        ${PREFIX}/bin/patchelf ${FORCE_RPATH} --set-rpath ${RUST_LLVM_RPATH} \
+          ${DESTDIR}${PREFIX}/lib/rustlib/${RUST_ARCH}/bin/${bin}
+.    endfor
+.  endif
+.  for lib in lib lib/rustlib/${RUST_ARCH}/lib \
+               lib/rustlib/${RUST_ARCH}/codegen-backends
+       for f in ${DESTDIR}${PREFIX}/${lib}/lib*.so; do                 \
+               [ ! -f $$f ] && continue;                               \
+               ${PREFIX}/bin/patchelf ${FORCE_RPATH} --set-rpath ${PREFIX}/lib $$f;    \
+       done
+.  endfor
+.endif
+
+.include "../../mk/bsd.pkg.mk"
Index: pkgsrc/lang/rust176-bin/buildlink3.mk
diff -u /dev/null pkgsrc/lang/rust176-bin/buildlink3.mk:1.1
--- /dev/null   Sun Jul  7 10:56:19 2024
+++ pkgsrc/lang/rust176-bin/buildlink3.mk       Sun Jul  7 10:56:19 2024
@@ -0,0 +1,13 @@
+# $NetBSD: buildlink3.mk,v 1.1 2024/07/07 10:56:19 wiz Exp $
+
+BUILDLINK_TREE+=       rust-bin
+
+.if !defined(RUST_BIN_BUILDLINK3_MK)
+RUST_BIN_BUILDLINK3_MK:=
+
+BUILDLINK_API_DEPENDS.rust-bin+=       rust-bin>=1.56.1<1.77
+BUILDLINK_PKGSRCDIR.rust-bin?=         ../../lang/rust176-bin
+BUILDLINK_PASSTHRU_DIRS+=              ${PREFIX}/lib/rustlib
+.endif
+
+BUILDLINK_TREE+=       -rust-bin
Index: pkgsrc/lang/rust176-bin/distinfo
diff -u /dev/null pkgsrc/lang/rust176-bin/distinfo:1.1
--- /dev/null   Sun Jul  7 10:56:19 2024
+++ pkgsrc/lang/rust176-bin/distinfo    Sun Jul  7 10:56:19 2024
@@ -0,0 +1,59 @@
+$NetBSD: distinfo,v 1.1 2024/07/07 10:56:19 wiz Exp $
+
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-aarch64-apple-darwin.tar.gz) = dfb3791161a7af45da105e018cc2b4f2597c8a4e65de24cd7c60b109ec3287e1
+SHA512 (rust-bin-1.76.0/rust-1.76.0-aarch64-apple-darwin.tar.gz) = b6397cd4c247be029b88d5353d6bd681b1e6dbf16d93ae782af13f7de8c791b0adb73ea17730fa62053e62dfe74f3ab7533005dfe80ca6c128539ac0f2e2dd5e
+Size (rust-bin-1.76.0/rust-1.76.0-aarch64-apple-darwin.tar.gz) = 249531855 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-aarch64-unknown-linux-gnu.tar.gz) = 0fd32be80b5886deee6fcda864e95a8fbc0fe5902d93d91c767f0752172cc9ef
+SHA512 (rust-bin-1.76.0/rust-1.76.0-aarch64-unknown-linux-gnu.tar.gz) = 
eccf96573009538a8fddbac2c4340e7fe9a1b0b40f51a393f4d48eaa1558dd288c710b76327395a3bd5c9ab952c7dfe5e3624f36697c7857bc8ff832712d2e4b
+Size (rust-bin-1.76.0/rust-1.76.0-aarch64-unknown-linux-gnu.tar.gz) = 461921893 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-aarch64-unknown-linux-musl.tar.gz) = 5af5d01534e0726aabf316df00bce9b24e8c1861e6e79d07cc19192593a93294
+SHA512 (rust-bin-1.76.0/rust-1.76.0-aarch64-unknown-linux-musl.tar.gz) = 
7aab97e1db8eaf7e473221ac1374c1cca33134d70e92312c635efb9255a99783d9c6a8d6947eb7691e57fd4eaa4eb3f7c936166e05a8231b20f372887705c886
+Size (rust-bin-1.76.0/rust-1.76.0-aarch64-unknown-linux-musl.tar.gz) = 372066702 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-aarch64-unknown-netbsd.tar.xz) = 0f7124b0c6a73947ddf76819af7fe692a185c96b139ae5fcc93ab29a483c40b5
+SHA512 (rust-bin-1.76.0/rust-1.76.0-aarch64-unknown-netbsd.tar.xz) = d1f8f749e5483ee8f375c03e1461dbc44700764eea1b70a3605eac4631c292a19e409dd1cba45f5d31c90b44b5dc8912d59c1d4d968106e3bd808d9725e23969
+Size (rust-bin-1.76.0/rust-1.76.0-aarch64-unknown-netbsd.tar.xz) = 163239404 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-aarch64_be-unknown-netbsd.tar.xz) = 0905eba5bb9d1dfdce3f169f415b7e915639d8ffdb0fb7ac3653f0ebf5d43da9
+SHA512 (rust-bin-1.76.0/rust-1.76.0-aarch64_be-unknown-netbsd.tar.xz) = 
f40935108fc5789dd28d4d02e2351e68d492393b0eb52fc4e0a9c8fc48d60eb4c5c32a30fb14c8f5e97a7bc4a6cae5cd4195b979da497589904661cc0a70091d
+Size (rust-bin-1.76.0/rust-1.76.0-aarch64_be-unknown-netbsd.tar.xz) = 162427248 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-armv6-unknown-netbsd-eabihf.tar.xz) = 27f9852b2fda9b9f421984d09c275b09fa13c9dca22131f741d55f31cf1c41d6
+SHA512 (rust-bin-1.76.0/rust-1.76.0-armv6-unknown-netbsd-eabihf.tar.xz) = 
4b8771f4dfb77a437e70bddd11c7c7f3011a05278a7f5ee68384777f0674d7a89a5d65adaf18aeef73c3f36d1a9d9c0c85018cc4fdbf3ba4cca00b21d6a36bb0
+Size (rust-bin-1.76.0/rust-1.76.0-armv6-unknown-netbsd-eabihf.tar.xz) = 138929352 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-armv7-unknown-netbsd-eabihf.tar.xz) = 402b541df35624c18cf3fb71375878c890886a2344c777f48727e4e4091bd532
+SHA512 (rust-bin-1.76.0/rust-1.76.0-armv7-unknown-netbsd-eabihf.tar.xz) = 
5616ab86b3a9fc3eaea90404e7f3683142550cc69beba3a31ad05ccbb02323890164d49dde95bc5d2752f2fa1ebf0f674faa00d1ef70bfa8e484a1e62638b402
+Size (rust-bin-1.76.0/rust-1.76.0-armv7-unknown-netbsd-eabihf.tar.xz) = 140850720 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-i586-unknown-netbsd.tar.xz) = 2699932e5fc3ea5de153d5eb878613c0dabdb0e23f20511968822cbf8a0bf27d
+SHA512 (rust-bin-1.76.0/rust-1.76.0-i586-unknown-netbsd.tar.xz) = ffb338ceb593308db86ce436f769a8da00d16dfe830bc6708cea012d7df8f90c01f55cf01ae9397573802f903c25d801bd8be354221a2e57ef77e2bbdd73deb9
+Size (rust-bin-1.76.0/rust-1.76.0-i586-unknown-netbsd.tar.xz) = 176714704 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-i686-unknown-linux-gnu.tar.gz) = 0c6a16c0a8f43260118d159947ddcf575662cc1f11c4b98d3ee49f952bfc8fa9
+SHA512 (rust-bin-1.76.0/rust-1.76.0-i686-unknown-linux-gnu.tar.gz) = 015f8fa17dcac31dd14c0d5125a1e2fcc199a6660628fd8b1a1c79ef3ed4225164443a1003dd480464cd49145461f58a64624e82dd991676771315e40ea17eff
+Size (rust-bin-1.76.0/rust-1.76.0-i686-unknown-linux-gnu.tar.gz) = 411504411 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-mipsel-unknown-netbsd.tar.xz) = 21a0939dc9fe2f7aa2a8d26a0aee021759a80b3256cea773d0c0087faf2aee4b
+SHA512 (rust-bin-1.76.0/rust-1.76.0-mipsel-unknown-netbsd.tar.xz) = b725b18e012fa80e389cbdef02a5795a1ba7c8ba0970ca921d329978e41661a1982c00a9437133588a3d287197ec9b03b6092e84503f275933a76976adccbfd9
+Size (rust-bin-1.76.0/rust-1.76.0-mipsel-unknown-netbsd.tar.xz) = 141716928 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-powerpc-unknown-netbsd.tar.xz) = f8d7fbac7022bb62ce9af91bdb1178f8a6b24163b91b44eca413d29f4566d0fa
+SHA512 (rust-bin-1.76.0/rust-1.76.0-powerpc-unknown-netbsd.tar.xz) = 059b9c5ed203927c10dee83d97fb5a1b467c580bfa6faf3785d346f0936d1cda068b7a9cd9df4de768ebf3e92b1e5b9bf5a638d76b4fe639e6bb45a466e0ff30
+Size (rust-bin-1.76.0/rust-1.76.0-powerpc-unknown-netbsd.tar.xz) = 187410204 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-riscv64gc-unknown-netbsd.tar.xz) = babe8e98cd6634e9a794c0da6a8b1ea0b6a0ff12648097e3102a7ec526d3dadc
+SHA512 (rust-bin-1.76.0/rust-1.76.0-riscv64gc-unknown-netbsd.tar.xz) = 0e4ae84e1619919267d40075c54e9b0579ee9afde186a18d1f8401129217cf4fdda2ccfd10f57c4eb5d50e02b468a32bca97d1eef66defa9378260a9994ee6c6
+Size (rust-bin-1.76.0/rust-1.76.0-riscv64gc-unknown-netbsd.tar.xz) = 173937160 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-sparc64-unknown-netbsd.tar.xz) = a542cec1f08307e7cebf9386dc7aa48fb8e02eec3df342203a371e3de797f617
+SHA512 (rust-bin-1.76.0/rust-1.76.0-sparc64-unknown-netbsd.tar.xz) = 5cdd98d845fda899430969f46116b3f94b16a91394af72ef4d5fc4df2eb6b611a897efc542710c734e701adaf9392aadd3ee2fa512bd2b3e368b8649a82ad4b8
+Size (rust-bin-1.76.0/rust-1.76.0-sparc64-unknown-netbsd.tar.xz) = 158099720 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-x86_64-apple-darwin.tar.gz) = 29e091e5e295a92728612a37abb9625d3f5dfe1f7c351cdd87a38940ef90a3a0
+SHA512 (rust-bin-1.76.0/rust-1.76.0-x86_64-apple-darwin.tar.gz) = 35823b826f9978f8ff9d44ac7df8e3bc4646651f07ece56fe92d305e53dda5d80288d055b6050ef92cf42b5bda18892adc677e6eb63795693572db407c97941f
+Size (rust-bin-1.76.0/rust-1.76.0-x86_64-apple-darwin.tar.gz) = 328963201 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-freebsd.tar.gz) = d95c3d265fb6bc48eeaff9e5f9ff8692b0716429d45887a0dc82633288256878
+SHA512 (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-freebsd.tar.gz) = b87aa7d981cc039dcce713702b58dfb78412b4f912a40c67dc9128bde832c681909791516da27536c536075cc1621b2249d6278f2907f4825e6b17122f2c9edc
+Size (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-freebsd.tar.gz) = 312059401 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-illumos.tar.gz) = 1a65c18867c7130710b2eb63c243cd4f6f0e2d809fddcbd0e4cc0a6a4f06f27a
+SHA512 (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-illumos.tar.gz) = 430b8330b2e7335b0a459c02aadb1c9af31dc2905348e78d4a854517c08628ce22624598103cb6d836fdfcabf388b253b9e15d61f718f7ab4586e20d4b0cd9f3
+Size (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-illumos.tar.gz) = 212187293 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-linux-gnu.tar.gz) = f5ea832a1e58fbc9b9cf31dce3057d4bf899c365f0bdec24e4302660da8ffb1d
+SHA512 (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-linux-gnu.tar.gz) = 36233a5d5c121e08afa692a5af9f438022167bc782c8e147162ec3814c715ab3e22a916d5143aeda3629addc8cf5b99a794eb94219d6e9e350c054f9b339a865
+Size (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-linux-gnu.tar.gz) = 323520820 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-linux-musl.tar.gz) = 1377afe3e78e1675ceebf417a54fee24e4dd28862b3297e5df44516d79914669
+SHA512 (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-linux-musl.tar.gz) = 
9edeb8ade83fd0182313a9c05df1f6fbc64777929ba3b82467f4be024ab971eebfef42e203059d033cbc32a52306a89035eeb65c820d3abb6bbdf19d17ef996a
+Size (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-linux-musl.tar.gz) = 450390469 bytes
+BLAKE2s (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-netbsd.tar.gz) = 973814ac54ad2098137b43d2490e3db6d713145505498db3e36af7d954599ebd
+SHA512 (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-netbsd.tar.gz) = 7e0f6420efb3e2d41e6b91886ae676f0e1172135a69ac0c28f2f610ac6753874a00341a9164b7a8fc08416bab4a9cb5e1f841fc6632f79dd036b088b8ad21d52
+Size (rust-bin-1.76.0/rust-1.76.0-x86_64-unknown-netbsd.tar.gz) = 286161975 bytes

Index: pkgsrc/lang/rust176-bin/files/install.sh
diff -u /dev/null pkgsrc/lang/rust176-bin/files/install.sh:1.1
--- /dev/null   Sun Jul  7 10:56:19 2024
+++ pkgsrc/lang/rust176-bin/files/install.sh    Sun Jul  7 10:56:19 2024
@@ -0,0 +1,971 @@
+#!/bin/bash
+# Copyright 2014 The Rust Project Developers. See the COPYRIGHT
+# file at the top-level directory of this distribution and at
+# http://rust-lang.org/COPYRIGHT.
+#
+# Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
+# http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
+# <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
+# option. This file may not be copied, modified, or distributed
+# except according to those terms.
+
+# No undefined variables
+set -u
+
+init_logging() {
+    local _abs_libdir="$1"
+    local _logfile="$_abs_libdir/$TEMPLATE_REL_MANIFEST_DIR/install.log"
+    LOGFILE="$_logfile"
+}
+
+log_line() {
+    local _line="$1"
+
+}
+
+msg() {
+    local _line="install: ${1-}"
+    echo "$_line"
+    log_line "$_line"
+}
+
+verbose_msg() {
+    if [ -n "${CFG_VERBOSE-}" ]; then
+       msg "${1-}"
+    else
+       log_line "install: ${1-}"
+    fi
+}
+
+step_msg() {
+    msg
+    msg "$1"
+    msg
+}
+
+verbose_step_msg() {
+    if [ -n "${CFG_VERBOSE-}" ]; then
+       msg
+       msg "$1"
+       msg
+    else
+       log_line ""
+       log_line "install: $1"
+       log_line ""
+    fi
+}
+
+warn() {
+    local _line="install: WARNING: $1"
+    echo "$_line" >&2
+    log_line "$_line"
+}
+
+err() {
+    local _line="install: error: $1"
+    echo "$_line" >&2
+    log_line "$_line"
+    exit 1
+}
+
+# A non-user error that is likely to result in a corrupted install
+critical_err() {
+    local _line="install: error: $1. see logs at '${LOGFILE-}'"
+    echo "$_line" >&2
+    log_line "$_line"
+    exit 1
+}
+
+need_ok() {
+    if [ $? -ne 0 ]
+    then
+        err "$1"
+    fi
+}
+
+critical_need_ok() {
+    if [ $? -ne 0 ]
+    then
+        critical_err "$1"
+    fi
+}
+
+want_ok() {
+    if [ $? -ne 0 ]; then
+       warn "$1"
+    fi
+}
+
+assert_nz() {
+    if [ -z "$1" ]; then err "assert_nz $2"; fi
+}
+
+need_cmd() {
+    if command -v $1 >/dev/null 2>&1
+    then verbose_msg "found $1"
+    else err "need $1"
+    fi
+}
+
+run() {
+    local _line="\$ $*"
+    "$@"
+    local _retval=$?
+    log_line "$_line"
+    return $_retval
+}
+
+write_to_file() {
+    local _msg="$1"
+    local _file="$2"
+    local _line="$ echo \"$_msg\" > \"$_file\""
+    echo "$_msg" > "$_file"
+    local _retval=$?
+    log_line "$_line"
+    return $_retval
+}
+
+append_to_file() {
+    local _msg="$1"
+    local _file="$2"
+    local _line="$ echo \"$_msg\" >> \"$_file\""
+    echo "$_msg" >> "$_file"
+    local _retval=$?
+    log_line "$_line"
+    return $_retval
+}
+
+make_dir_recursive() {
+    local _dir="$1"
+    local _line="$ umask 022 && mkdir -p \"$_dir\""
+    umask 022 && mkdir -p "$_dir"
+    local _retval=$?
+    log_line "$_line"
+    return $_retval
+}
+
+putvar() {
+    local t
+    local tlen
+    eval t=\$$1
+    eval tlen=\${#$1}
+}
+
+valopt() {
+    VAL_OPTIONS="$VAL_OPTIONS $1"
+
+    local op=$1
+    local default=$2
+    shift
+    shift
+    local doc="$*"
+    if [ $HELP -eq 0 ]
+    then
+        local uop=$(echo $op | tr 'a-z-' 'A-Z_')
+        local v="CFG_${uop}"
+        eval $v="$default"
+        for arg in $CFG_ARGS
+        do
+            if echo "$arg" | grep -q -- "--$op="
+            then
+                local val=$(echo "$arg" | cut -f2 -d=)
+                eval $v=$val
+            fi
+        done
+        putvar $v
+    else
+        if [ -z "$default" ]
+        then
+            default="<none>"
+        fi
+        op="${op}=[${default}]"
+        printf "    --%-30s %s\n" "$op" "$doc"
+    fi
+}
+
+opt() {
+    BOOL_OPTIONS="$BOOL_OPTIONS $1"
+
+    local op=$1
+    local default=$2
+    shift
+    shift
+    local doc="$*"
+    local flag=""
+
+    if [ $default -eq 0 ]
+    then
+        flag="enable"
+    else
+        flag="disable"
+        doc="don't $doc"
+    fi
+
+    if [ $HELP -eq 0 ]
+    then
+        for arg in $CFG_ARGS
+        do
+            if [ "$arg" = "--${flag}-${op}" ]
+            then
+                op=$(echo $op | tr 'a-z-' 'A-Z_')
+                flag=$(echo $flag | tr 'a-z' 'A-Z')
+                local v="CFG_${flag}_${op}"
+                eval $v=1
+                putvar $v
+            fi
+        done
+    else
+        if [ ! -z "${META-}" ]
+        then
+            op="$op=<$META>"
+        fi
+        printf "    --%-30s %s\n" "$flag-$op" "$doc"
+     fi
+}
+
+flag() {
+    BOOL_OPTIONS="$BOOL_OPTIONS $1"
+
+    local op=$1
+    shift
+    local doc="$*"
+
+    if [ $HELP -eq 0 ]
+    then
+        for arg in $CFG_ARGS
+        do
+            if [ "$arg" = "--${op}" ]
+            then
+                op=$(echo $op | tr 'a-z-' 'A-Z_')
+                local v="CFG_${op}"
+                eval $v=1
+                putvar $v
+            fi
+        done
+    else
+        if [ ! -z "${META-}" ]
+        then
+            op="$op=<$META>"
+        fi
+        printf "    --%-30s %s\n" "$op" "$doc"
+     fi
+}
+
+validate_opt () {
+    for arg in $CFG_ARGS
+    do
+        local is_arg_valid=0
+        for option in $BOOL_OPTIONS
+        do
+            if test --disable-$option = $arg
+            then
+                is_arg_valid=1
+            fi
+            if test --enable-$option = $arg
+            then
+                is_arg_valid=1
+            fi
+            if test --$option = $arg
+            then
+                is_arg_valid=1
+            fi
+        done
+        for option in $VAL_OPTIONS
+        do
+            if echo "$arg" | grep -q -- "--$option="
+            then
+                is_arg_valid=1
+            fi
+        done
+        if [ "$arg" = "--help" ]
+        then
+            echo
+            echo "No more help available for Configure options,"
+            echo "check the Wiki or join our IRC channel"
+            break
+        else
+            if test $is_arg_valid -eq 0
+            then
+                err "Option '$arg' is not recognized"
+            fi
+        fi
+    done
+}
+
+absolutify() {
+    local file_path="$1"
+    local file_path_dirname="$(dirname "$file_path")"
+    local file_path_basename="$(basename "$file_path")"
+    local file_abs_path="$(abs_path "$file_path_dirname")"
+    local file_path="$file_abs_path/$file_path_basename"
+    # This is the return value
+    RETVAL="$file_path"
+}
+
+# Prints the absolute path of a directory to stdout
+abs_path() {
+    local path="$1"
+    # Unset CDPATH because it causes havok: it makes the destination unpredictable
+    # and triggers 'cd' to print the path to stdout. Route `cd`'s output to /dev/null
+    # for good measure.
+    (unset CDPATH && cd "$path" > /dev/null && pwd)
+}
+
+uninstall_legacy() {
+    local _abs_libdir="$1"
+
+    local _uninstalled_something=false
+
+    # Replace commas in legacy manifest list with spaces
+    _legacy_manifest_dirs=`echo "$TEMPLATE_LEGACY_MANIFEST_DIRS" | sed "s/,/ /g"`
+
+    # Uninstall from legacy manifests
+    local _md
+    for _md in $_legacy_manifest_dirs; do
+       # First, uninstall from the installation prefix.
+       # Errors are warnings - try to rm everything in the manifest even if some fail.
+       if [ -f "$_abs_libdir/$_md/manifest" ]
+       then
+
+           # iterate through installed manifest and remove files
+           local _p;
+           while read _p; do
+               # the installed manifest contains absolute paths
+               msg "removing legacy file $_p"
+               if [ -f "$_p" ]
+               then
+                   run rm -f "$_p"
+                   want_ok "failed to remove $_p"
+               else
+                   warn "supposedly installed file $_p does not exist!"
+               fi
+           done < "$_abs_libdir/$_md/manifest"
+
+           # If we fail to remove $md below, then the
+           # installed manifest will still be full; the installed manifest
+           # needs to be empty before install.
+           msg "removing legacy manifest $_abs_libdir/$_md/manifest"
+           run rm -f "$_abs_libdir/$_md/manifest"
+           # For the above reason, this is a hard error
+           need_ok "failed to remove installed manifest"
+
+           # Remove $template_rel_manifest_dir directory
+           msg "removing legacy manifest dir $_abs_libdir/$_md"
+           run rm -R "$_abs_libdir/$_md"
+           want_ok "failed to remove $_md"
+
+           _uninstalled_something=true
+       fi
+    done
+
+    RETVAL="$_uninstalled_something"
+}
+
+uninstall_components() {
+    local _abs_libdir="$1"
+    local _dest_prefix="$2"
+    local _components="$3"
+
+    # We're going to start by uninstalling existing components. This
+    local _uninstalled_something=false
+
+    # First, try removing any 'legacy' manifests from before
+    # rust-installer
+    uninstall_legacy "$_abs_libdir"
+    assert_nz "$RETVAL", "RETVAL"
+    if [ "$RETVAL" = true ]; then
+       _uninstalled_something=true;
+    fi
+
+    # Load the version of the installed installer
+    local _installed_version=
+    if [ -f "$abs_libdir/$TEMPLATE_REL_MANIFEST_DIR/rust-installer-version" ]; then
+       _installed_version=`cat "$_abs_libdir/$TEMPLATE_REL_MANIFEST_DIR/rust-installer-version"`
+
+       # Sanity check
+       if [ ! -n "$_installed_version" ]; then critical_err "rust installer version is empty"; fi
+    fi
+
+    # If there's something installed, then uninstall
+    if [ -n "$_installed_version" ]; then
+       # Check the version of the installed installer
+       case "$_installed_version" in
+
+           # If this is a previous version, then upgrade in place to the
+           # current version before uninstalling.
+           2 )
+               # The only change between version 2 -> 3 is that components are placed
+               # in subdirectories of the installer tarball. There are no changes
+               # to the installed data format, so nothing to do.
+               ;;
+
+           # This is the current version. Nothing need to be done except uninstall.
+           "$TEMPLATE_RUST_INSTALLER_VERSION")
+               ;;
+
+           # If this is an unknown (future) version then bail.
+           * )
+               echo "The copy of $TEMPLATE_PRODUCT_NAME at $_dest_prefix was installed using an"
+               echo "unknown version ($_installed_version) of rust-installer."
+               echo "Uninstall it first with the installer used for the original installation"
+               echo "before continuing."
+               exit 1
+               ;;
+       esac
+
+       local _md="$_abs_libdir/$TEMPLATE_REL_MANIFEST_DIR"
+       local _installed_components="$(cat "$_md/components")"
+
+       # Uninstall (our components only) before reinstalling
+       local _available_component
+       for _available_component in $_components; do
+           local _installed_component
+           for _installed_component in $_installed_components; do
+               if [ "$_available_component" = "$_installed_component" ]; then
+                   msg "uninstalling component '$_available_component'"
+                   local _component_manifest="$_md/manifest-$_installed_component"
+
+                   # Sanity check: there should be a component manifest
+                   if [ ! -f "$_component_manifest" ]; then
+                       critical_err "installed component '$_installed_component' has no manifest"
+                   fi
+
+                   # Iterate through installed component manifest and remove files
+                   local _directive
+                   while read _directive; do
+
+                       local _command=${_directive%%:*}
+                       local _file=${_directive#*:}
+
+                       # Sanity checks
+                       if [ ! -n "$_command" ]; then critical_err "malformed installation directive"; fi
+                       if [ ! -n "$_file" ]; then critical_err "malformed installation directive"; fi
+
+                       case "$_command" in
+                           file)
+                               verbose_msg "removing file $_file"
+                               if [ -f "$_file" ]; then
+                                   run rm -f "$_file"
+                                   want_ok "failed to remove $_file"
+                               else
+                                   warn "supposedly installed file $_file does not exist!"
+                               fi
+                               ;;
+
+                           dir)
+                               verbose_msg "removing directory $_file"
+                               run rm -r "$_file"
+                               want_ok "unable to remove directory $_file"
+                               ;;
+
+                           *)
+                               critical_err "unknown installation directive"
+                               ;;
+                       esac
+
+                   done < "$_component_manifest"
+
+                   # Remove the installed component manifest
+                   verbose_msg "removing component manifest $_component_manifest"
+                   run rm "$_component_manifest"
+                   # This is a hard error because the installation is unrecoverable
+                   critical_need_ok "failed to remove installed manifest for component '$_installed_component'"
+
+                   # Update the installed component list
+                   local _modified_components="$(sed "/^$_installed_component\$/d" "$_md/components")"
+                   write_to_file "$_modified_components" "$_md/components"
+                   critical_need_ok "failed to update installed component list"
+               fi
+           done
+       done
+
+       # If there are no remaining components delete the manifest directory,
+       # but only if we're doing an uninstall - if we're doing an install,
+       # then leave the manifest directory around to hang onto the logs,
+       # and any files not managed by the installer.
+       if [ -n "${CFG_UNINSTALL-}" ]; then
+           local _remaining_components="$(cat "$_md/components")"
+           if [ ! -n "$_remaining_components" ]; then
+               verbose_msg "removing manifest directory $_md"
+               run rm -r "$_md"
+               want_ok "failed to remove $_md"
+
+               maybe_unconfigure_ld
+           fi
+       fi
+
+       _uninstalled_something=true
+    fi
+
+    # There's no installed version. If we were asked to uninstall, then that's a problem.
+    if [ -n "${CFG_UNINSTALL-}" -a "$_uninstalled_something" = false ]
+    then
+       err "unable to find installation manifest at $CFG_LIBDIR/$TEMPLATE_REL_MANIFEST_DIR"
+    fi
+}
+
+install_components() {
+    local _src_dir="$1"
+    local _abs_libdir="$2"
+    local _dest_prefix="$3"
+    local _components="$4"
+
+    local _component
+    for _component in $_components; do
+
+       msg "installing component '$_component'"
+
+       # The file name of the manifest we're installing from
+       local _input_manifest="$_src_dir/$_component/manifest.in"
+
+       # Sanity check: do we have our input manifests?
+       if [ ! -f "$_input_manifest" ]; then
+           critical_err "manifest for $_component does not exist at $_input_manifest"
+       fi
+
+       # The installed manifest directory
+       local _md="$_abs_libdir/$TEMPLATE_REL_MANIFEST_DIR"
+
+       # The file name of the manifest we're going to create during install
+       local _installed_manifest="$_md/manifest-$_component"
+
+       # Create the installed manifest, which we will fill in with absolute file paths
+       touch "$_installed_manifest"
+       critical_need_ok "failed to create installed manifest"
+
+       # Add this component to the installed component list
+       append_to_file "$_component" "$_md/components"
+       critical_need_ok "failed to update components list for $_component"
+
+       # Now install, iterate through the new manifest and copy files
+       local _directive
+       while read _directive; do
+
+           local _command=${_directive%%:*}
+           local _file=${_directive#*:}
+
+           # Sanity checks
+           if [ ! -n "$_command" ]; then critical_err "malformed installation directive"; fi
+           if [ ! -n "$_file" ]; then critical_err "malformed installation directive"; fi
+
+           # Decide the destination of the file
+           local _file_install_path="$_dest_prefix/$_file"
+
+           case "$_file" in
+               etc/*)
+                   local _f=${_file#"etc/"}
+                   _file_install_path="$CFG_DESTDIR_PREFIX/share/doc/cargo/$_f"
+                   ;;
+               bin/*)
+                   local _f=${_file#"bin/"}
+                   _file_install_path="$CFG_BINDIR/$_f"
+                   ;;
+               lib/*)
+                   local _f=${_file#"lib/"}
+                   _file_install_path="$CFG_LIBDIR/$_f"
+                   ;;
+               share/man/*)
+                   local _f=${_file#"share/man/"}
+                   _file_install_path="$CFG_DESTDIR_PREFIX/$PKGMANDIR/$_f"
+                   ;;
+               share/doc/*)
+            # HACK: Try to support overriding --docdir.  Paths with the form
+            # "share/doc/$product/" can be redirected to a single --docdir
+            # path. If the following detects that --docdir has been specified
+            # then it will replace everything preceeding the "$product" path
+            # component. The problem here is that the combined rust installer
+            # contains two "products": rust and cargo; so the contents of those
+            # directories will both be dumped into the same directory; and the
+            # contents of those directories are _not_ disjoint. Since this feature
+            # is almost entirely to support 'make install' anyway I don't expect
+            # this problem to be a big deal in practice.
+                   if [ "$CFG_DOCDIR" != "<default>" ]; then
+                       local _f=${_file#"share/doc/"*/}
+                       _file_install_path="$CFG_DOCDIR/$_f"
+                   fi
+                   ;;
+               share/*)
+                   local _f=${_file#"share/"}
+                   _file_install_path="$CFG_DATADIR/$_f"
+                   ;;
+           esac
+
+
+           # Make sure there's a directory for it
+           make_dir_recursive "$(dirname "$_file_install_path")"
+           critical_need_ok "directory creation failed"
+
+           # Make the path absolute so we can uninstall it later without
+           # starting from the installation cwd
+           absolutify "$_file_install_path"
+           _file_install_path="$RETVAL"
+           assert_nz "$_file_install_path" "file_install_path"
+
+           case "$_command" in
+               file )
+
+                   verbose_msg "copying file $_file_install_path"
+
+                   maybe_backup_path "$_file_install_path"
+
+                   local mode=644
+                   if test -x "$_src_dir/$_component/$_file"; then
+                       mode=755
+                   fi
+                   case "$_file" in
+                       bin/*) mode=755
+                              ;;
+                   esac
+                   run cp "$_src_dir/$_component/$_file" "$_file_install_path"
+                   run chmod $mode "$_file_install_path"
+                   critical_need_ok "file creation failed"
+
+                   # Update the manifest
+                   append_to_file "file:$_file_install_path" "$_installed_manifest"
+                   critical_need_ok "failed to update manifest"
+
+                   ;;
+
+               dir )
+
+                   verbose_msg "copying directory $_file_install_path"
+
+                   maybe_backup_path "$_file_install_path"
+
+                   run cp -R "$_src_dir/$_component/$_file" "$_file_install_path"
+                   critical_need_ok "failed to copy directory"
+
+                    # Set permissions. 0755 for dirs, 644 for files
+                    run chmod -R u+rwX,go+rX,go-w "$_file_install_path"
+                    critical_need_ok "failed to set permissions on directory"
+
+                   # Update the manifest
+                   append_to_file "dir:$_file_install_path" "$_installed_manifest"
+                   critical_need_ok "failed to update manifest"
+                   ;;
+
+               *)
+                   critical_err "unknown installation directive"
+                   ;;
+           esac
+       done < "$_input_manifest"
+
+    done
+}
+
+maybe_configure_ld() {
+    local _abs_libdir="$1"
+
+    local _ostype="$(uname -s)"
+    assert_nz "$_ostype"  "ostype"
+
+    if [ "$_ostype" = "Linux" -a ! -n "${CFG_DISABLE_LDCONFIG-}" ]; then
+
+       # Fedora-based systems do not configure the dynamic linker to look
+       # /usr/local/lib, which is our default installation directory. To
+       # make things just work, try to put that directory in
+       # /etc/ld.so.conf.d/rust-installer-v1 so ldconfig picks it up.
+       # Issue #30.
+       #
+       # This will get rm'd when the last component is uninstalled in
+       # maybe_unconfigure_ld.
+       if [ "$_abs_libdir" = "/usr/local/lib" -a -d "/etc/ld.so.conf.d" ]; then
+           echo "$_abs_libdir" > "/etc/ld.so.conf.d/rust-installer-v1-$TEMPLATE_REL_MANIFEST_DIR.conf"
+           if [ $? -ne 0 ]; then
+               # This shouldn't happen if we've gotten this far
+               # installing to /usr/local
+               warn "failed to update /etc/ld.so.conf.d. this is unexpected"
+           fi
+       fi
+
+       verbose_msg "running ldconfig"
+       if [ -n "${CFG_VERBOSE-}" ]; then
+           ldconfig
+       else
+           ldconfig 2> /dev/null
+       fi
+       if [ $? -ne 0 ]
+       then
+            warn "failed to run ldconfig. this may happen when not installing as root. run with --verbose to see the error"
+       fi
+    fi
+}
+
+maybe_unconfigure_ld() {
+    local _ostype="$(uname -s)"
+    assert_nz "$_ostype"  "ostype"
+
+    if [ "$_ostype" != "Linux" ]; then
+       return 0
+    fi
+
+    rm "/etc/ld.so.conf.d/rust-installer-v1-$TEMPLATE_REL_MANIFEST_DIR.conf" 2> /dev/null
+    # Above may fail since that file may not have been created on install
+}
+
+# Doing our own 'install'-like backup that is consistent across platforms
+maybe_backup_path() {
+    local _file_install_path="$1"
+
+    if [ -e "$_file_install_path" ]; then
+       msg "backing up existing file at $_file_install_path"
+       run mv -f "$_file_install_path" "$_file_install_path.old"
+       critical_need_ok "failed to back up $_file_install_path"
+    fi
+}
+
+install_uninstaller() {
+    local _src_dir="$1"
+    local _src_basename="$2"
+    local _abs_libdir="$3"
+
+    local _uninstaller="$_abs_libdir/$TEMPLATE_REL_MANIFEST_DIR/uninstall.sh"
+    msg "creating uninstall script at $_uninstaller"
+    run cp "$_src_dir/$_src_basename" "$_uninstaller"
+    critical_need_ok "unable to install uninstaller"
+}
+
+do_preflight_sanity_checks() {
+    local _src_dir="$1"
+    local _dest_prefix="$2"
+
+    # Sanity check: can we can write to the destination?
+    verbose_msg "verifying destination is writable"
+    make_dir_recursive "$CFG_LIBDIR"
+    need_ok "can't write to destination. consider \`sudo\`."
+    touch "$CFG_LIBDIR/rust-install-probe" > /dev/null
+    if [ $? -ne 0 ]
+    then
+       err "can't write to destination. consider \`sudo\`."
+    fi
+    rm "$CFG_LIBDIR/rust-install-probe"
+    need_ok "failed to remove install probe"
+
+    # Sanity check: don't install to the directory containing the installer.
+    # That would surely cause chaos.
+    verbose_msg "verifying destination is not the same as source"
+    local _prefix_dir="$(abs_path "$dest_prefix")"
+    if [ "$_src_dir" = "$_dest_prefix" -a "${CFG_UNINSTALL-}" != 1 ]; then
+       err "cannot install to same directory as installer"
+    fi
+}
+
+verbose_msg "looking for install programs"
+verbose_msg
+
+need_cmd mkdir
+need_cmd printf
+need_cmd cut
+need_cmd grep
+need_cmd uname
+need_cmd tr
+need_cmd sed
+need_cmd chmod
+need_cmd env
+need_cmd pwd
+
+CFG_ARGS="${@:-}"
+
+HELP=0
+if [ "${1-}" = "--help" ]
+then
+    HELP=1
+    shift
+    echo
+    echo "Usage: $0 [options]"
+    echo
+    echo "Options:"
+    echo
+else
+    verbose_step_msg "processing arguments"
+fi
+
+OPTIONS=""
+BOOL_OPTIONS=""
+VAL_OPTIONS=""
+
+flag uninstall "only uninstall from the installation prefix"
+valopt destdir "" "set installation root"
+valopt prefix "/usr/local" "set installation prefix"
+
+# Avoid prepending an extra / to the prefix path if there's no destdir
+# NB: CFG vars here are undefined when passing --help
+if [ -z "${CFG_DESTDIR-}" ]; then
+    CFG_DESTDIR_PREFIX="${CFG_PREFIX-}"
+else
+    CFG_DESTDIR_PREFIX="$CFG_DESTDIR/$CFG_PREFIX"
+fi
+
+# NB This isn't quite the same definition as in `configure`.
+# just using 'lib' instead of configure's CFG_LIBDIR_RELATIVE
+valopt without "" "comma-separated list of components to not install"
+valopt components "" "comma-separated list of components to install"
+flag list-components "list available components"
+valopt sysconfdir "$CFG_DESTDIR_PREFIX/etc" "install system configuration files"
+valopt bindir "$CFG_DESTDIR_PREFIX/bin" "install binaries"
+valopt libdir "$CFG_DESTDIR_PREFIX/lib" "install libraries"
+valopt datadir "$CFG_DESTDIR_PREFIX/share" "install data"
+# NB We repeat datadir default value because we don't set CFG_DATADIR in --help
+valopt mandir "${CFG_DATADIR-"$CFG_DESTDIR_PREFIX/share"}/man" "install man pages in PATH"
+# NB See the docdir handling in install_components for an explanation of this
+# weird <default> string
+valopt docdir "\<default\>" "install documentation in PATH"
+opt ldconfig 1 "run ldconfig after installation (Linux only)"
+opt verify 1 "obsolete"
+flag verbose "run with verbose output"
+
+if [ $HELP -eq 1 ]
+then
+    echo
+    exit 0
+fi
+
+verbose_step_msg "validating arguments"
+validate_opt
+
+# Template configuration.
+# These names surrounded by '%%` are replaced by sed when generating install.sh
+# FIXME: Might want to consider loading this from a file and not generating install.sh
+
+# Rust or Cargo
+TEMPLATE_PRODUCT_NAME='Rust'
+# rustlib or cargo
+TEMPLATE_REL_MANIFEST_DIR=rustlib
+# 'Rust is ready to roll.' or 'Cargo is cool to cruise.'
+TEMPLATE_SUCCESS_MESSAGE='rust installed.'
+# Locations to look for directories containing legacy, pre-versioned manifests
+TEMPLATE_LEGACY_MANIFEST_DIRS='rustlib,cargo'
+# The installer version
+TEMPLATE_RUST_INSTALLER_VERSION='3'
+
+# OK, let's get installing ...
+
+# This is where we are installing from
+src_dir="$(abs_path $(dirname "$0"))"
+
+# The name of the script
+src_basename="$(basename "$0")"
+
+# If we've been run as 'uninstall.sh' (from the existing installation)
+# then we're doing a full uninstall, as opposed to the --uninstall flag
+# which just means 'uninstall my components'.
+if [ "$src_basename" = "uninstall.sh" ]; then
+    if [ "${*:-}" != "" ]; then
+       # Currently don't know what to do with arguments in this mode
+       err "uninstall.sh does not take any arguments"
+    fi
+    CFG_UNINSTALL=1
+    CFG_DESTDIR_PREFIX="$(abs_path "$src_dir/../../")"
+    CFG_LIBDIR="$(abs_path "$src_dir/../")"
+fi
+
+# This is where we are installing to
+dest_prefix="$CFG_DESTDIR_PREFIX"
+
+# Open the components file to get the list of components to install.
+# NB: During install this components file is read from the installer's
+# source dir, during a full uninstall it's read from the manifest dir,
+# and thus contains all installed components.
+components=`cat "$src_dir/components"`
+
+# Sanity check: do we have components?
+if [ ! -n "$components" ]; then
+    err "unable to find installation components"
+fi
+
+# If the user asked for a component list, do that and exit
+if [ -n "${CFG_LIST_COMPONENTS-}" ]; then
+    echo
+    echo "# Available components"
+    echo
+    for component in $components; do
+       echo "* $component"
+    done
+    echo
+    exit 0
+fi
+
+# If the user specified which components to install/uninstall,
+# then validate that they exist and select them for installation
+if [ -n "$CFG_COMPONENTS" ]; then
+    # Remove commas
+    user_components="$(echo "$CFG_COMPONENTS" | sed "s/,/ /g")"
+    for user_component in $user_components; do
+       found=false
+       for my_component in $components; do
+           if [ "$user_component" = "$my_component" ]; then
+               found=true
+           fi
+       done
+       if [ "$found" = false ]; then
+           err "unknown component: $user_component"
+       fi
+    done
+    components="$user_components"
+fi
+
+if [ -n "$CFG_WITHOUT" ]; then
+    without_components="$(echo "$CFG_WITHOUT" | sed "s/,/ /g")"
+    for without_component in $without_components; do
+       components="$(echo "$components" | sed "s/$without_component//" | sed "s/$without_component//")"
+    done
+fi
+
+if [ -z "$components" ]; then
+    if [ -z "${CFG_UNINSTALL-}" ]; then
+       err "no components selected for installation"
+    else
+       err "no components selected for uninstallation"
+    fi
+fi
+
+do_preflight_sanity_checks "$src_dir" "$dest_prefix"
+
+# Using an absolute path to libdir in a few places so that the status
+# messages are consistently using absolute paths.
+absolutify "$CFG_LIBDIR"
+abs_libdir="$RETVAL"
+assert_nz "$abs_libdir" "abs_libdir"
+
+# Create the manifest directory, where we will put our logs
+make_dir_recursive "$abs_libdir/$TEMPLATE_REL_MANIFEST_DIR"
+need_ok "failed to create $TEMPLATE_REL_MANIFEST_DIR"
+
+# Log messages and commands
+init_logging "$abs_libdir"
+
+# First do any uninstallation, including from legacy manifests. This
+# will also upgrade the metadata of existing installs.
+uninstall_components "$abs_libdir" "$dest_prefix" "$components"
+
+# If we're only uninstalling then exit
+if [ -n "${CFG_UNINSTALL-}" ]
+then
+    echo
+    echo "    $TEMPLATE_PRODUCT_NAME is uninstalled."
+    echo
+    exit 0
+fi
+
+# Create the manifest directory again! uninstall_legacy
+# may have deleted it.
+make_dir_recursive "$abs_libdir/$TEMPLATE_REL_MANIFEST_DIR"
+need_ok "failed to create $TEMPLATE_REL_MANIFEST_DIR"
+
+# Drop the version number into the manifest dir
+write_to_file "$TEMPLATE_RUST_INSTALLER_VERSION" "$abs_libdir/$TEMPLATE_REL_MANIFEST_DIR/rust-installer-version"
+critical_need_ok "failed to write installer version"
+
+# Install the uninstaller
+
+# Install each component
+install_components "$src_dir" "$abs_libdir" "$dest_prefix" "$components"
+
+# Make dynamic libraries available to the linker
+maybe_configure_ld "$abs_libdir"
+
+echo
+echo "    $TEMPLATE_SUCCESS_MESSAGE"
+echo
+
+



Home | Main Index | Thread Index | Old Index